'        MAX7219,
'     .

        Device = 18F4458
        Xtal = 8

' **   **
		Symbol Clk	= PORTC.0				'  
		Symbol Dta  = PORTC.6				'  
		Symbol Load = PORTC.1				'   

' **  .    ,     7219 **
		Symbol Decode_Reg 	9				'       ()  . 
		Symbol Lum_Reg		10				'  
		Symbol Scan_Reg	    11				'     Scan-limit.
		Symbol Switch_Reg   12				'   /
		Symbol Test_Reg		15				'    (  )

'	Max_Digit	Con	5					'   

' **   **
  		Dim Counts		As Word			'     
		Dim Max_Disp	As Word			' 16-       MAX7219
		Dim Max_Dp		As Byte			'     (0-4)
		Dim Register	As Byte			'    MAX7219
		Dim R_Val		As Byte			'     
		Dim Digit		As Byte			'      MAX_Disp (0-3)
		Dim Position	As Byte			'     (1-4)

' **  MAX7219 ** 
'        .
'  MAX7219 ,    16 ,    
'     3 (4    0-3)
'   5
' BCD decoding to the lower 4 digits 
'  . 
'   

		Register = Scan_Reg				'    
		R_Val = 3						'  3, (    0-3)
		GoSub Transfer					'     16-   MAX7219

		Register = Lum_Reg				'   
		R_Val = 1						'   5, ( )
		GoSub Transfer					'     16-   MAX7219

		Register = Decode_Reg			'   
		R_Val = %00011111				'    
		GoSub Transfer					'     16-   MAX7219

		Register = Switch_Reg			'    
		R_Val = 1						'  , ( )
		GoSub Transfer					'     16-   MAX7219

		Register = Test_Reg				'   
		R_Val = 1						'  , ( )
		GoSub Transfer					'     16-   MAX7219


' 		*****   *****
'       1  16- ,    1 
'         
' ,        "Max_Disp"
'      Max_Dp (0-4)

		Max_Dp = 3						'     
	
Again:	For Counts = 1 To 9999			'  
			Max_Disp = Counts			'   Max_Disp  
			GoSub Display				'   
			DelayMS 150					'         
		Next							'  

		For Counts = 9999 To 1 Step -1	'  
			Max_Disp = Counts			'    Max_Disp  
			GoSub Display				'   
			DelayMS 150					'         
		Next							'  		
		GoTo Again						'  


' **  **
'    "MAX_DISP   
'  "MAX_DP"       (0-3)
'   15  ,    
'   7     ,  
' 

Display:
		Digit = 0												'   0   Max_Disp 
		For Position = 4 To 1 Step -1							'       		
			Register = Position									'    ()
			R_Val = Dig Max_Disp,Digit							'     Max_Disp			
			If Max_Disp < 10 And Position = 3 Then R_Val = 15	'      
			If Max_Disp < 100 And Position = 2 Then R_Val = 15	'      
			If Max_Disp < 1000 And Position = 1 Then R_Val = 15	'      
			If Max_Disp < 10000 And Position = 0 Then R_Val = 15 '      
			If Digit = Max_Dp Then R_Val.7 = 1					'   ,   Max_Dp
			GoSub Transfer										'  16-   MAX7219
			If Digit >= 3 Then Digit = 0						'      
			Digit = Digit + 1									' Point to next Digit within Max_Disp
		Next													'  
		Return													'   

'  16-   MAX7219 
'          ,    
Transfer:
        Low Load									'   MAX7219
        SHOut Dta,Clk,MsbFirst,[Register,R_Val] 	'  .    ,     .
		High Load									'  .    MAX7219
		DelayUS 2									'  ,     				
		 
		Return										'   
        
